# 3.5.19. scheduler

resource type: scheduler
  Attributes:

    - master? (master) – the master on which this scheduler is running, or None if it is inactive

    - name (string) – name of this scheduler

    - schedulerid (integer) – the ID of this scheduler

A scheduler initiates builds, often in response to changes from change sources. A particular scheduler (by name) runs on at most one master at a time.

Note

This data type and associated endpoints is planned to be merged with forcescheduler data type when bug #2673 will be resolved.

## 3.5.19.1. Update Methods

All update methods are available as attributes of `master.data.updates`.

class buildbot.data.schedulers.Scheduler

findSchedulerId(name)
  Parameters:

    name (string) – scheduler name

  Returns:

    scheduler ID via Deferred

  Get the ID for the given scheduler name, inventing one if necessary.

trySetSchedulerMaster(schedulerid, masterid)
  Parameters:

    - schedulerid (integer) – scheduler ID to try to claim

    - masterid (integer) – this master’s master ID

  Returns:

    `True` or `False`, via Deferred

  Try to claim the given scheduler for the given master and return `True` if the scheduler is to be activated on that master.

## 3.5.19.2. Endpoints

path: /masters/{masterid}/schedulers
  Path Keys:

    masterid (number) – the id of the master

This path selects all schedulers for a given master

`GET`
  `returns`

    `collection` of `scheduler`

path: /masters/{masterid}/schedulers/{schedulerid}
  Path Keys:

    - masterid (number) – the id of the master

    - schedulerid (number) – the id of the scheduler

This path selects one scheduler by id for a given master

`GET`
  `returns`

    `collection` of `scheduler`

path: /schedulers

This path selects all schedulers

`GET`
  `returns`

    `collection` of `scheduler`

path: /schedulers/{schedulerid}
  Path Keys:

    schedulerid (number) – the id of the scheduler

This path selects one scheduler by id

`GET`
  `returns`

    `collection` of `scheduler`